#ifndef __COMMON_H
#define __COMMON_H

#include <stdlib.h>
#include "defines.h"


#ifdef __cplusplus
extern "C" {
#endif

//MESSAGE:
void showmsg(char* fmt, ...);
void errmsg(char* fmt, ...);
void errmsg_exit(char* fmt, ...);

//common blackboard for ERROR responses
#define ERR_NOERROR		(0)
extern  int   ERR_Type;
extern  char* ERR_Msg;
void err_SetMsg(int errtype, char* fmt, ...);

bool msg_SetLogFile(char* logfile);
void msg_CloseLogFile(void);
bool err_SetLogFile(char* logfile);
void err_CloseLogFile(void);


//TIMER:
unsigned long timer_nowtime(void);
void delay_ms(unsigned long delaytime);


//KEYBOARD:
#define KBENTER         0x000d
#define KBTAB           0x0009
#define KBESC           0x001b
#define KBBACKSPACE     0x0008
#define KBSPACE         0x0020

#define KBLEFT          0xff4b
#define KBRIGHT         0xff4d
#define KBUP            0xff48
#define KBDOWN          0xff50

#define KBHOME          0xff47
#define KBEND           0xff4f
#define KBPGUP          0xff49
#define KBPGDN          0xff51

#define KBCHOME         0xff77 //Ctrl + Home
#define KBCEND          0xff75 //Ctrl + End
#define KBINS           0xff52
#define KBDEL           0xff53

#define KBF1            0xff3b
#define KBF2            0xff3c
#define KBF3            0xff3d
#define KBF4            0xff3e
#define KBF5            0xff3f
#define KBF6            0xff40
#define KBF7            0xff41
#define KBF8            0xff42
#define KBF9            0xff43
#define KBF10           0xff44
#define KBF11           0xff85
#define KBF12           0xff86
#define KBCF11          0xff89 //Ctrl + F11
#define KBCF12          0xff8a //Ctrl + F12
#define KBAF11          0xff85 //Alt + F11
#define KBAF12          0xff86 //Alt + F12
unsigned keyboard_getkey(void);
unsigned keyboard_waitkey(void);


//MEMORY:
void* mem_alloc(size_t size);
void* mem_realloc(void* pointer, size_t size);

#ifdef __cplusplus
}
#endif 
#endif

