#ifndef __IO_H
#define __IO_H

#include "defines.h"


extern bool IO_inUse;

#ifdef __cplusplus
extern "C" {
#endif

bool io_init(void);
//-- if the above function return false, ERR_Type may be settled as the following number:
     #define ERROR_IOINITFAIL    (ERR_NOERROR + 100)

void io_close(void);

void io_outpdw(unsigned addr, unsigned long val);
unsigned long io_inpdw(unsigned addr);

void io_outpw(unsigned addr, unsigned val);
unsigned io_inpw(unsigned addr);

void io_outpb(unsigned addr, unsigned char val);
unsigned char io_inpb(unsigned addr);

unsigned char read_sb_regb(unsigned char idx);
unsigned long read_sb_reg(unsigned char idx);
void write_sb_regb(unsigned char idx, unsigned char val);
void write_sb_reg(unsigned char idx, unsigned long val);  //idx must = 0 (mod 4)

unsigned char read_nb_regb(unsigned char idx);
unsigned long read_nb_reg(unsigned char idx);
void write_nb_regb(unsigned char idx, unsigned char val);
void write_nb_reg(unsigned char idx, unsigned long val);  //idx must = 0 (mod 4)

#ifdef __cplusplus
}
#endif

#endif

