#ifndef __PWM_H
#define __PWM_H

#include "defines.h"
#include "pwmdx.h"

#ifdef __cplusplus
extern "C" {
#endif

bool pwm_Initialize(unsigned baseaddr, int clkmode, int irqmode);
//-- if the above function return false, ERR_Type may be settled as the following number:
     #define ERROR_PWM_INUSE	 (ERR_NOERROR + 300)
     #define ERROR_PWM_NOIO		 (ERR_NOERROR + 301)

void pwm_Close(void);


void pwm_SetBaseClock(int clock);
void pwm_SetPulse(int channel, unsigned long period, unsigned long duty);		//resolution: 1us
void pwm_SetPulse_10MHZ(int channel, unsigned long period, unsigned long duty);	//resolution: 0.1us

/*
void pwm_BackupAllSettings(void);
void pwm_RestoreAllSettings(void);
*/

#ifdef __cplusplus
}
#endif 

#endif

