#ifndef __PWMDX_H
#define __PWMDX_H

#ifdef __cplusplus
extern "C" {
#endif

void pwm_SetBaseAddress(unsigned baseaddr);
unsigned pwm_SetDefaultBaseAddress(void);

#define PWMCLOCK_10MHZ    (0) //don't want to use enum:p
#define PWMCLOCK_50MHZ    (1)
void pwm_SelectClock(int clock);

#define PWMIRQ1         (8)   //don't want to use enum:p
#define PWMIRQ3         (2)
#define PWMIRQ4         (4)
#define PWMIRQ5         (5)
#define PWMIRQ6         (7)
#define PWMIRQ7         (6)
#define PWMIRQ9         (1)
#define PWMIRQ10        (3)
#define PWMIRQ11        (9)
#define PWMIRQ12        (11)
#define PWMIRQ14        (13)
#define PWMIRQ15        (15)
#define PWMIRQ_DISABLE  (0)
void pwm_SetIRQ(int pwmirq);

void pwm_EnablePin(int channel);
void pwm_DisablePin(int channel);
void pwm_EnableMultiPin(unsigned long channels);
void pwm_DisableMultiPin(unsigned long channels);

void pwm_Lock(int channel);
void pwm_Unlock(int channel);
void pwm_LockMulti(unsigned long channels);
void pwm_UnlockMulti(unsigned long channels);

void pwm_EnableINT(int channel);
void pwm_DisableINT(int channel);
void pwm_EnableMultiINT(unsigned long channels);
void pwm_DisableMultiINT(unsigned long channels);

void pwm_ClearMultiFLAG(unsigned long channels);
unsigned long pwm_ReadMultiFLAG(unsigned long channels);

void pwm_EnablePWM(int channel);
void pwm_DisablePWM(int channel);
void pwm_EnableMultiPWM(unsigned long channels);
void pwm_DisableMultiPWM(unsigned long channels);

#define PWM_COUNT_MODE        (0)  //don't want to use enum:p
#define PWM_CONTINUE_MODE     (1)
void pwm_SetCountingMode(int channel, int mode);
int  pwm_ReadCountingMode(int channel);

#define PWM_WAVEFORM_NORMAL   (0)  //don't want to use enum:p
#define PWM_WAVEFORM_INVERSE  (1)
void pwm_SetWaveform(int channel, int mode);

void pwm_SetPulseCount(int channel, unsigned long count);
void pwm_SetCtrlREG(int channel, unsigned long creg);
void pwm_SetHREG(int channel, unsigned long hreg);
void pwm_SetLREG(int channel, unsigned long lreg);

unsigned long pwm_ReadPulseCount(int channel);
unsigned long pwm_ReadCtrlREG(int channel);
unsigned long pwm_ReadHREG(int channel);
unsigned long pwm_ReadLREG(int channel);

void pwm_SetSyncREG(unsigned long sreg);
void pwm_SetINTREG(unsigned long ireg);
unsigned long pwm_ReadSyncREG(void);
unsigned long pwm_ReadINTREG(void);

void pwm_SetPWMSettingREG(unsigned long psreg);
unsigned long pwm_ReadPWMSettingREG(void);

#ifdef __cplusplus
}
#endif 

#endif

